<template>
  <div class="[ a-icon-select-ui ]" :data-panel-position="position">
    <ss-select
      v-slot="{
        isOpen,
        selectedOptions,
        pointerIndex,
        $selected,
        $disabled,
        $reset,
      }"
      :options="options"
      :value="selected"
      :track-by="trackBy"
      :multiple="multiple"
      :close-on-select="!multiple"
      @change="onChange"
    >
      <div class="relative">
        <div class="inline-flex shadow-sm">
          <div>
            <!--
              @slot Icon element representing the dropdown data. Slot bindings:  
                    `reset {function}` - Reset selected options.  
                    `hasSelected {boolean}` - Whether any options have been selected or not.
            -->
            <slot
              name="icon"
              :reset="$reset"
              :has-selected="!!selectedOptions.length"
            />
          </div>

          <ss-select-toggle>
            <!--
              @slot Element for opening and closing the dropdown. Slot bindings:  
                    `isOpen {boolean}` - Whether Select is open or not.
            -->
            <slot name="caret" :is-open="isOpen" />
          </ss-select-toggle>
        </div>

        <transition
          enter-active-class="transition ease-out duration-200"
          enter-class="transform opacity-0 scale-95"
          enter-to-class="transform opacity-100 scale-100"
          leave-active-class="transition ease-in duration-75"
          leave-class="transform opacity-100 scale-100"
          leave-to-class="transform opacity-0 scale-95"
        >
          <div v-show="isOpen" class="[ panel-outer-wrapper ]">
            <div
              class="[ panel-inner-wrapper ]"
              :class="[{ 'a-scrollbar-cs': customScrollbar }]"
            >
              <template v-for="(option, index) in options">
                <ss-select-option :key="index" :value="option" :index="index">
                  <!--
                    @slot Custom option template. Slot bindings:  
                          `option {object}` - The option to render.  
                          `isDisabled {boolean}` - Whether the option is disabled or not.  
                          `isSelected {boolean}` - Whether the option has been selected or not.  
                          `isFocused {boolean}` - Whether the option is currently being focused.
                  -->
                  <slot
                    name="option"
                    :option="option"
                    :is-disabled="$disabled(option)"
                    :is-selected="$selected(option)"
                    :is-focused="pointerIndex === index"
                  />
                </ss-select-option>
              </template>
            </div>
          </div>
        </transition>
      </div>
    </ss-select>
  </div>
</template>

<script>
export default {
  name: 'AIconSelectUi',
  props: {
    /** Array of available options (Objects). */
    options: {
      type: Array,
      default: () => [],
    },
    /** Array of initially selected options (Objects). */
    selected: {
      type: Array,
      default: () => [],
    },
    /** Unique option key (supports dot notation). */
    trackBy: {
      type: String,
      default: 'id',
    },
    /** Option key to disable options (supports dot notation). */
    disableBy: {
      type: String,
      default: 'disabled',
    },
    /** Enable multiple mode. */
    multiple: {
      type: Boolean,
      default: true,
    },
    /** Panel position relative to the icon (left | center | right). */
    position: {
      type: String,
      default: 'right',
      validator: value => ['left', 'center', 'right'].includes(value),
    },
    /** Whether to use customized scrollbars or not. */
    customScrollbar: {
      type: Boolean,
      default: true,
    },
  },
  methods: {
    onChange(selected) {
      // Remove repeated options
      /* prettier-ignore */
      const selectedMap = selected.reduce((M, o) => M.set(o[this.trackBy], o), new Map());
      const selectedOptions = [...selectedMap.values()];
      /**
       * Triggered on change (emits the changed selected options).
       * @event changed
       */
      this.$emit('changed', selectedOptions);
    },
  },
};
</script>

<style scoped>
/* prettier-ignore */
.a-icon-select-ui {
  --a-icon-select-ui--panel--def-mt: 0.5rem; /* theme('spacing.2') */
  --a-icon-select-ui--panel--def-max-h: 100%; /* theme('maxHeight.full') */
  --a-icon-select-ui--panel--def-min-w: 12rem; /* theme('minWidth.xl') */
  --a-icon-select-ui--panel--def-bg-color: hsl(210, 20%, 98%); /* theme('colors.gray.50') */
  --a-icon-select-ui--panel--def-rounded: 0.25rem; /* theme('borderRadius.default') */
}

/* prettier-ignore */
.a-icon-select-ui .panel-outer-wrapper,
.a-icon-select-ui .panel-inner-wrapper {
  border-radius: var(--a-icon-select-ui--panel--rounded, var(--a-icon-select-ui--panel--def-rounded));
}

/* prettier-ignore */
.a-icon-select-ui .panel-outer-wrapper {
  position: absolute;
  margin-top: var(--a-icon-select-ui--panel--mt, var(--a-icon-select-ui--panel--def-mt));
  box-shadow: 0 10px 15px -3px rgba(0, 0, 0, 0.1), 0 4px 6px -2px rgba(0, 0, 0, 0.05); /* theme('boxShadow.lg') */
  z-index: 10; /* theme('zIndex.10') */
}

.a-icon-select-ui[data-panel-position='left'] .panel-outer-wrapper {
  transform-origin: top left;
  left: 0;
}
.a-icon-select-ui[data-panel-position='center'] .panel-outer-wrapper {
  transform-origin: top left;
  left: 50%;
  transform: translateX(-50%);
}
.a-icon-select-ui[data-panel-position='right'] .panel-outer-wrapper {
  transform-origin: top right;
  right: 0;
}

/* prettier-ignore */
.a-icon-select-ui .panel-inner-wrapper {
  max-height: var(--a-icon-select-ui--panel--max-h, var(--a-icon-select-ui--panel--def-max-h));
  min-width: var(--a-icon-select-ui--panel--min-w, var(--a-icon-select-ui--panel--def-min-w));
  background-color: var(--a-icon-select-ui--panel--bg-color, var(--a-icon-select-ui--panel--def-bg-color));
  overflow: auto;
  box-shadow: 0 0 0 1px rgba(0, 0, 0, 0.05); /* theme('boxShadow.xs') */
}
</style>
